import { __decorate } from "tslib";
import { Vue, Component, Prop, Emit } from 'vue-property-decorator';
import { Table as ElTable, TableColumn as ElTableColumn, Pagination as ElPagination, } from 'element-ui';
import { DEFAULT_PAGE_SIZE, DEFAULT_PAGE_NUMBER } from './helper';
import Expand from './Expand';
const localEvents = { 'current-change': true, 'size-change': true };
let DataTable = class DataTable extends Vue {
    get filteredColumns() {
        return this.columns.filter(col => !col.isValid || col.isValid());
    }
    get filteredListeners() {
        const filtered = {};
        const listeners = this.$listeners;
        Object.keys(listeners).forEach(k => {
            if (!localEvents[k]) {
                filtered[k] = listeners[k];
            }
        });
        return filtered;
    }
    handleCurrentChange() { } // eslint-disable-line
    handleSizeChange() { } // eslint-disable-line
};
__decorate([
    Prop({ type: Array, default: () => [] })
], DataTable.prototype, "data", void 0);
__decorate([
    Prop({ type: Array, default: () => [] })
], DataTable.prototype, "columns", void 0);
__decorate([
    Prop({ type: Boolean, default: false })
], DataTable.prototype, "hidePagination", void 0);
__decorate([
    Prop({ type: Number, default: DEFAULT_PAGE_NUMBER })
], DataTable.prototype, "currentPage", void 0);
__decorate([
    Prop({ type: Number, default: DEFAULT_PAGE_SIZE })
], DataTable.prototype, "pageSize", void 0);
__decorate([
    Prop({ type: Number, default: 0 })
], DataTable.prototype, "total", void 0);
__decorate([
    Prop(Array)
], DataTable.prototype, "pageSizes", void 0);
__decorate([
    Emit('current-change')
], DataTable.prototype, "handleCurrentChange", null);
__decorate([
    Emit('size-change')
], DataTable.prototype, "handleSizeChange", null);
DataTable = __decorate([
    Component({
        components: {
            ElTable,
            ElTableColumn,
            ElPagination,
            Expand,
        },
    })
], DataTable);
export default DataTable;
