import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isNumber, getControl } from 'handie-vue';
import { StringFieldHeadlessWidget } from 'handie-vue/dist/widgets';
let InputEditStringFieldWidget = class InputEditStringFieldWidget extends StringFieldHeadlessWidget {
    render(h) {
        const attrs = { placeholder: this.getPlaceholder() };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.field;
            if (isNumber(min)) {
                attrs.minlength = min;
            }
            if (isNumber(max)) {
                attrs.maxlength = max;
            }
        }
        return h(getControl('Input'), {
            props: { value: this.value },
            attrs,
            on: { input: this.onChange },
        });
    }
};
InputEditStringFieldWidget = __decorate([
    Component
], InputEditStringFieldWidget);
export default InputEditStringFieldWidget;
