import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isNumber, getControl } from 'handie-vue';
import { TextFieldHeadlessWidget } from 'handie-vue/dist/widgets';
import defaultBehaviors from './behavior';
let TextareaEditTextFieldWidget = class TextareaEditTextFieldWidget extends TextFieldHeadlessWidget {
    created() {
        this.setBehaviors('field.textarea', defaultBehaviors);
    }
    render(h) {
        let showWordLimit = this.config.showWordLimit;
        if (showWordLimit === undefined) {
            showWordLimit = this.getBehavior('showWordLimit');
        }
        const attrs = {
            placeholder: this.getPlaceholder(),
            rows: this.config.rows || this.getBehavior('rows'),
        };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.field;
            if (isNumber(min)) {
                attrs.minlength = min;
            }
            if (isNumber(max)) {
                attrs.maxlength = max;
            }
        }
        return h(getControl('Input'), {
            props: {
                type: 'textarea',
                value: this.value,
                resize: 'none',
                showWordLimit,
            },
            attrs,
            on: { input: this.onChange },
        });
    }
};
TextareaEditTextFieldWidget = __decorate([
    Component
], TextareaEditTextFieldWidget);
export default TextareaEditTextFieldWidget;
