import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { isNumber, getControl } from 'handie-vue';
import { StringFilterHeadlessWidget } from 'handie-vue/dist/widgets';
let InputStringFilterWidget = class InputStringFilterWidget extends StringFilterHeadlessWidget {
    render(h) {
        const attrs = { placeholder: this.getPlaceholder() };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.filter;
            if (isNumber(min)) {
                attrs.minlength = min;
            }
            if (isNumber(max)) {
                attrs.maxlength = max;
            }
        }
        return h(getControl('Input'), {
            props: { value: this.value },
            attrs,
            on: { input: this.onChange },
        });
    }
};
InputStringFilterWidget = __decorate([
    Component
], InputStringFilterWidget);
export default InputStringFilterWidget;
